%%%%% ps1 question 1

clearvars;
close all;
clc;


%%%%% logistic map

x0 = 0.5;
a  = 0.9;

T  = 20;

ts = (1:1:T)';

xt = zeros(T,1);

for i=1:T-1
    
    xt(1)   = x0;
    xt(i+1) = a*xt(i)*(1-xt(i));

end


n = 1000;
xmin = 0;
xmax = 1;

xs = linspace(xmin,xmax,n);

xstar = max(0,(a-1)/a);

figure(1)
set(gcf,'DefaultLineLineWidth', 1);

subplot(1,2,1)
hold on
plot(xs,xs,'k--')
plot(xs,a*xs.*(1-xs),'b-','LineWidth',2)
plot(linspace(0,1,10),xstar*ones(10,1),'k--')
for i=1:5
plot(xt(i),xt(i+1),'kd',xt(i)*ones(10,1),linspace(0,xt(i+1),10),'k:',...
                        linspace(xt(i),xt(i+1),10),xt(i+1)*ones(10,1),'k-',... %,...
                        xt(i+1)*ones(10,1),linspace(xt(i+1),xt(i+2),10),'k-')

end
hold off    
axis([0 1 0 1])

set(get(gcf,'CurrentAxes'),'FontSize',18,'LineWidth', 1.5)
xlabel('$x_t$' ,'Interpreter','latex')
ylabel('$x_{t+1}$' ,'Interpreter','latex')
set(gca,'DefaultTextInterpreter', 'latex','TickLabelInterpreter','latex')


ts = (0:1:T-1)';

subplot(1,2,2)
hold on
plot(ts,xt,'bd-',ts,xstar*ones(T,1),'k--')
hold off
axis([0 T-1 0 1])

set(get(gcf,'CurrentAxes'),'FontSize',18,'LineWidth', 1.5)
xlabel('$t$' ,'Interpreter','latex')
ylabel('$x_{t}$' ,'Interpreter','latex')
set(gca,'DefaultTextInterpreter', 'latex','TickLabelInterpreter','latex')
h = legend('$x_t$','$x^*$','Location','NorthEast');
set(h,'Interpreter','latex');



